/**
 * Copyright (C) 2020 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "utils/String16.h"

int main(void) {
  android::String16 str{u"hello world"};
  android::String16 substr{u"hello"};
  const size_t begin = substr.size();
  const size_t len = std::numeric_limits<size_t>::max();
  if (str.remove(len, begin) != android::OK) {
    return EXIT_FAILURE;
  }
  if (strcmp16(str, substr) != 0) {
    return EXIT_FAILURE;
  }
  return EXIT_SUCCESS;
}
